/* This file contains the definitions of a Robot that can count how many beepers it has.
   It also has the ability to pick up an entire pile of beepers.
   
written by Scott McElfresh

*/



package kareltherobot;


public class CountingRobot extends TurningRobot
{

        public CountingRobot(int street, int avenue, Direction direction, int numberOfBeepers)
        {       
           super(street, avenue, direction, numberOfBeepers);
        }
 
 //***** 
 //  does the robot have any beepers in it's bag
 private boolean hasBeepers()
 {
   if (anyBeepersInBeeperBag())
      return true;
   else
      return false;
 }
 
  //***** 
 //  are there any beepers at this intersection?
 private boolean beepersHere()
 {
   return (nextToABeeper());
  
 }

  //****
  // pick up all beepers at this intersection
  public void pickPile()
  {
    while (beepersHere())
       pickBeeper();
  }
  
 //***** 
 // returns how many beepers the robot has.
 public int numBeepers()
 {
   int countBeepers = 0;
   while (hasBeepers())
   {   
      putBeeper();
      countBeepers = countBeepers + 1;
   }
   pickPile();
  
   return countBeepers;
 }
 //*******************
 // has robot turn around and return to left side of screen
 public void goHome()
 {
    turnAround();
    while (frontIsClear())
        move();
 }
 


}